<?php

namespace Gigneo\Elementor\Widgets;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

use Elementor\Core\Kits\Documents\Tabs\Global_Typography;
use Elementor\Group_Control_Border;
use Elementor\Group_Control_Box_Shadow;
use Elementor\Group_Control_Text_Shadow;
use Elementor\Group_Control_Typography;
use Elementor\Widget_Base;
use Elementor\Controls_Manager;

/**
 * Gigneo Elementor Login Widget
 *
 * @since 0.0.1
 */
class Login extends Widget_Base {


	/**
	 * Get widget unique name.
	 *
	 * @return string
	 */
	public function get_name() {
		return 'gigneo-login';
	}

	/**
	 * Get widget title.
	 *
	 * This is the name displayed in the Elementor panel.
	 *
	 * @return string
	 */
	public function get_title() {
		return esc_html__( 'Login', 'gigneo' );
	}

	/**
	 * Get widget icon.
	 *
	 * Define the icon that will appear in the Elementor panel.
	 *
	 * @return string
	 */
	public function get_icon() {
		return 'eicon-ehp-forms gn-label';
	}

	/**
	 * Get widget categories.
	 *
	 * Defines the category under which the widget will be listed.
	 *
	 * @return array
	 */
	public function get_categories() {
		return array( 'gigneo-widgets' );
	}

	/**
	 * Get widget keywords.
	 *
	 * Helps users find the widget in Elementor search.
	 *
	 * @return array
	 */
	public function get_keywords() {
		return array( 'auth', 'login' );
	}

	/**
	 * Register widget controls.
	 *
	 * Adds controls/fields to the Elementor editor for this widget.
	 */
	protected function register_controls() {
		$this->start_controls_section(
			'section_general',
			array(
				'label' => esc_html__( 'General', 'gigneo' ),
			)
		);

		$this->add_control(
			'form_title',
			array(
				'label'                => esc_html__( 'Title', 'gigneo' ),
				'type'                 => Controls_Manager::SWITCHER,
				'label_on'             => esc_html__( 'Show', 'gigneo' ),
				'label_off'            => esc_html__( 'Hide', 'gigneo' ),
				'return_value'         => 'yes',
				'default'              => 'yes',
				'selectors_dictionary' => array(
					'yes' => 'block',
					''    => 'none',
				),
				'selectors'            => array(
					'{{WRAPPER}} .gn-title' => 'display: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'form_description',
			array(
				'label'                => esc_html__( 'Description', 'gigneo' ),
				'type'                 => Controls_Manager::SWITCHER,
				'label_on'             => esc_html__( 'Show', 'gigneo' ),
				'label_off'            => esc_html__( 'Hide', 'gigneo' ),
				'return_value'         => 'yes',
				'default'              => 'yes',
				'selectors_dictionary' => array(
					'yes' => 'block',
					''    => 'none',
				),
				'selectors'            => array(
					'{{WRAPPER}} .gn-description' => 'display: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'title_alignment',
			array(
				'label'      => esc_html__( 'Alignment', 'gigneo' ),
				'type'       => Controls_Manager::CHOOSE,
				'options'    => array(
					'left'    => array(
						'title' => esc_html__( 'Left', 'gigneo' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center'  => array(
						'title' => esc_html__( 'Center', 'gigneo' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'   => array(
						'title' => esc_html__( 'Right', 'gigneo' ),
						'icon'  => 'eicon-text-align-right',
					),
					'justify' => array(
						'title' => esc_html__( 'Justified', 'gigneo' ),
						'icon'  => 'eicon-text-align-justify',
					),
				),
				'default'    => '',
				'selectors'  => array(
					'{{WRAPPER}} .gn-title, .gn-description' => 'text-align: {{VALUE}};',
				),
				'conditions' => array(
					'relation' => 'or',
					'terms'    => array(
						array(
							'name'     => 'form_title',
							'operator' => '===',
							'value'    => 'yes',
						),
						array(
							'name'     => 'form_description',
							'operator' => '===',
							'value'    => 'yes',
						),
					),
				),
			)
		);

		$this->add_control(
			'form_have_account',
			array(
				'label'                => esc_html__( "Don't Have Account", 'gigneo' ),
				'type'                 => Controls_Manager::SWITCHER,
				'label_on'             => esc_html__( 'Show', 'gigneo' ),
				'label_off'            => esc_html__( 'Hide', 'gigneo' ),
				'return_value'         => 'yes',
				'default'              => 'yes',
				'selectors_dictionary' => array(
					'yes' => 'block',
					''    => 'none',
				),
				'selectors'            => array(
					'{{WRAPPER}} .gn-auth-action-text' => 'display: {{VALUE}};',
				),
				'separator'            => 'before',
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'title_style',
			array(
				'label' => esc_html__( 'Title', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'title_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-heading-area .gn-title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'title_typography',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_PRIMARY,
				),
				'selector' => '{{WRAPPER}} .gn-auth-heading-area .gn-title',
			)
		);

		$this->add_group_control(
			Group_Control_Text_Shadow::get_type(),
			array(
				'name'     => 'title_text_shadow',
				'selector' => '{{WRAPPER}} .gn-auth-heading-area .gn-title',
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'description_style',
			array(
				'label' => esc_html__( 'Description', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'description_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-heading-area .gn-description' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'description_typography',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_PRIMARY,
				),
				'selector' => '{{WRAPPER}} .gn-auth-heading-area .gn-description',
			)
		);

		$this->add_responsive_control(
			'description_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-heading-area .gn-description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'social_auth_style',
			array(
				'label' => esc_html__( 'Social Auth', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'social_auth_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-social-auth .gn-title',
			)
		);

		$this->add_responsive_control(
			'social_auth_space_between',
			array(
				'label'      => esc_html__( 'Space Between', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 30,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth' => 'gap: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'social_auth_size',
			array(
				'label'      => __( 'Icon Size', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min'  => 10,
						'max'  => 30,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon img' => 'max-width: {{SIZE}}{{UNIT}}; max-height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'social_auth_min_height',
			array(
				'label'      => esc_html__( 'Min Height', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'vh' ),
				'range'      => array(
					'px' => array(
						'min'  => 0,
						'max'  => 1000,
						'step' => 1,
					),
					'%'  => array(
						'min' => 0,
						'max' => 100,
					),
					'vh' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon' => 'min-height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs( 'social_auth_button_style_tabs' );

		$this->start_controls_tab(
			'social_auth_button_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'social_auth_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'social_auth_button_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'social_auth_button_box_shadow',
				'selector' => '{{WRAPPER}} .gn-social-auth .gn-social-auth-icon',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'social_auth_button_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'social_auth_hover_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:hover .gn-title' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'social_auth_button_border_color_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'social_auth_button_box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:hover',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'social_auth_button_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'social_auth_button_border_color_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'social_auth_button_border_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'social_auth_button_box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-social-auth .gn-social-auth-icon:focus',
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'social_auth_button_border',
				'separator' => 'before',
				'selector'  => '{{WRAPPER}} .gn-social-auth .gn-social-auth-icon',
			)
		);

		$this->add_responsive_control(
			'social_auth_button_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'social_auth_button_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-icon' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'separator_heading',
			array(
				'label'     => esc_html__( 'Separator', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'separator_typography',
				'selector' => '{{WRAPPER}} .gn-social-auth .gn-social-auth-separator',
			)
		);

		$this->add_control(
			'separator_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'separator_background_color',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth-separator' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'separator_alignment',
			array(
				'label'     => esc_html__( 'Justify Content', 'gigneo' ),
				'type'      => Controls_Manager::CHOOSE,
				'options'   => array(
					'flex-start' => array(
						'title' => esc_html__( 'Left', 'gigneo' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center'     => array(
						'title' => esc_html__( 'Center', 'gigneo' ),
						'icon'  => 'eicon-text-align-center',
					),
					'flex-end'   => array(
						'title' => esc_html__( 'Right', 'gigneo' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'center',
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator-wrapper' => 'justify-content: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'separator_text_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth-separator' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'separator_line_heading',
			array(
				'label'     => esc_html__( 'Line', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_control(
			'separator_color',
			array(
				'label'     => esc_html__( 'Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator-wrapper::before' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'separator_width',
			array(
				'label'      => esc_html__( 'Width', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'vw' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 1000,
					),
					'%'  => array(
						'min' => 0,
						'max' => 100,
					),
					'vw' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator-wrapper::before' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'separator_height',
			array(
				'label'      => esc_html__( 'Height', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'vh' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 1000,
					),
					'%'  => array(
						'min' => 0,
						'max' => 100,
					),
					'vh' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator-wrapper::before' => 'height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'separator_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-social-auth .gn-social-auth-separator-wrapper' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'fields_style',
			array(
				'label' => esc_html__( 'Fields', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'fields_label_heading',
			array(
				'label'     => esc_html__( 'Label', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'label_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field label',
			)
		);

		$this->add_control(
			'label_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field label' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'label_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field label' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'fields_input_heading',
			array(
				'label'     => esc_html__( 'Input', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'input_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-form-field input[type="text"], {{WRAPPER}} .gn-form-field input[type="email"], {{WRAPPER}} .gn-form-field input[type="password"]',
			)
		);

		$this->add_control(
			'input_text_color',
			array(
				'label'     => esc_html__( 'Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input' => 'color: {{VALUE}};',
					'{{WRAPPER}} .gn-form-field input:-webkit-autofill,
                     {{WRAPPER}} .gn-form-field input:-webkit-autofill:focus,
                     {{WRAPPER}} .gn-form-field input:-webkit-autofill:hover'
					=> '-webkit-text-fill-color: {{VALUE}} !important; 
                    caret-color: {{VALUE}} !important;',
				),
			)
		);

		$this->add_control(
			'input_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input' => 'background-color: {{VALUE}};',
					'{{WRAPPER}} .gn-form-field input:-webkit-autofill,
                     {{WRAPPER}} .gn-form-field input:-webkit-autofill:focus,
                     {{WRAPPER}} .gn-form-field input:-webkit-autofill:hover'
					=> '-webkit-box-shadow: 0 0 0 1000px {{VALUE}} inset !important; 
                    box-shadow: 0 0 0 1000px {{VALUE}} inset !important;',
				),
			)
		);

		$this->add_control(
			'input_placeholder_color',
			array(
				'label'     => esc_html__( 'Placeholder Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input::placeholder' => 'color: {{VALUE}}; opacity: 1;',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'box_shadow_normal',
				'selector' => '{{WRAPPER}} .gn-form-field input',
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'input_border',
				'selector' => '{{WRAPPER}} .gn-form-field input',
			)
		);

		$this->add_responsive_control(
			'input_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-field input' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'input_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-field input' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs( 'form_field_style_tabs' );

		$this->start_controls_tab(
			'form_field_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'input_border_color_hover',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input:hover:not(:focus)' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input:hover:not(:focus)' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-form-field input:hover:not(:focus)',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'form_field_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'background_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'input_border_color_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field input:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-form-field input:focus',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'form_field_error',
			array( 'label' => esc_html__( 'Error', 'gigneo' ) )
		);

		$this->add_control(
			'input_border_color_error',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-register-continue-btn:error' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_control(
			'eye_icon_heading',
			array(
				'label'     => esc_html__( 'Icon', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

        $this->add_responsive_control(
            'eye_icon_size',
            array(
                'label'      => esc_html__( 'Size', 'gigneo' ),
                'type'       => Controls_Manager::SLIDER,
                'size_units' => array( 'px', '%', 'em', 'rem' ),
                'range'      => array(
                    'px' => array(
                        'min' => 0,
                        'max' => 30,
                        'step' => 1,
                    ),
                ),
                'default'    => array(
                    'unit' => 'px',
                    'size' => 20,
                ),
                'selectors'  => array(
                    '{{WRAPPER}} .gn-form-field .gn-auth-input-wrapper .gn-password-revealed' => 'font-size: {{SIZE}}{{UNIT}};',
                ),
            )
        );

		$this->add_control(
			'eye_icon_color',
			array(
				'label'     => esc_html__( 'Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field .gn-auth-input-wrapper .gn-password-revealed' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'eye_icon_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'vw' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-field .gn-auth-input-wrapper .gn-password-revealed' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'remember_me_style',
			array(
				'label' => esc_html__( 'Remember Me', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'remember_me_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-form-field-checkbox>label',
			)
		);

		$this->add_control(
			'remember_me_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-form-field-checkbox>label' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'remember_me_padding_left',
			array(
				'label'      => esc_html__( 'Space Between', 'gigneo' ),
				'type'       => Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', '%' ),
				'range'      => array(
					'px' => array(
						'min' => 0,
						'max' => 30,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-form-field-checkbox>label' => 'padding-left: calc(18px + {{SIZE}}{{UNIT}});',
				),
			)
		);

		$this->add_control(
			'checkbox_heading',
			array(
				'label'     => esc_html__( 'Checkbox', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'checkbox_size',
			array(
				'label'      => __( 'Size', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min'  => 10,
						'max'  => 30,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-field-checkbox label::before' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}}; font-size: calc({{SIZE}}{{UNIT}} - 4px);',
					'{{WRAPPER}} .gn-form-field-checkbox:has(input[type=checkbox]:checked) label::after' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}}; font-size: calc({{SIZE}}{{UNIT}} - 4px);',
				),
			)
		);

		$this->start_controls_tabs( 'checkbox_tabs' );

		$this->start_controls_tab(
			'checkbox_tab',
			array( 'label' => esc_html__( 'Unchecked', 'gigneo' ) )
		);

		$this->add_control(
			'checkbox_background_color',
			array(
				'label'     => __( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field-checkbox label::before' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'checkbox_border_color',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field-checkbox label::before' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'checkbox_secondary_tab',
			array( 'label' => esc_html__( 'Checked', 'gigneo' ) )
		);

		$this->add_control(
			'checkbox_secondary_background_color',
			array(
				'label'     => __( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field-checkbox:has(input[type=checkbox]:checked) label::after' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'checkbox_secondary_border_color',
			array(
				'label'     => esc_html__( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field-checkbox:has(input[type=checkbox]:checked) label::after' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'checkbox_secondary_icon_color',
			array(
				'label'     => esc_html__( 'Icon Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-field-checkbox:has(input[type=checkbox]:checked) label::after' => 'color: {{VALUE}};',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'forget_password_style',
			array(
				'label' => esc_html__( 'Forget Password', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'forget_password_typography',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_PRIMARY,
				),
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password',
			)
		);

		$this->start_controls_tabs( 'forget_password_style_tabs' );

		$this->start_controls_tab(
			'forget_password_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'forget_password_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_text_decoration',
			array(
				'label'     => esc_html__( 'Text Decoration', 'gigneo' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'underline',
				'options'   => array(
					'none'         => esc_html__( 'None', 'gigneo' ),
					'underline'    => esc_html__( 'Underline', 'gigneo' ),
					'overline'     => esc_html__( 'Overline', 'gigneo' ),
					'line-through' => esc_html__( 'Line Through', 'gigneo' ),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'text-decoration: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'forget_password_box_shadow',
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'forget_password_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'forget_password_text_color_hover',
			array(
				'label'     => __( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:hover' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_border_color_hover',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_text_decoration_hover',
			array(
				'label'     => esc_html__( 'Text Decoration', 'gigneo' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'underline',
				'options'   => array(
					'none'         => esc_html__( 'None', 'gigneo' ),
					'underline'    => esc_html__( 'Underline', 'gigneo' ),
					'overline'     => esc_html__( 'Overline', 'gigneo' ),
					'line-through' => esc_html__( 'Line Through', 'gigneo' ),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:hover' => 'text-decoration: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'forget_password_box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:hover',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'forget_password_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'forget_password_text_color_focus',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:focus' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_background_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'forget_password_border_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'forget_password_box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password:focus',
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'forget_password_border',
				'separator' => 'before',
				'selector'  => '{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password',
			)
		);

		$this->add_responsive_control(
			'forget_password_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'forget_password_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'forget_password_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-form-fields .gn-form-field .gn-forgot-password' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'sign_in_button_style',
			array(
				'label' => esc_html__( 'Sign In Button', 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'sign_in_button_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-auth-action-btn',
			)
		);

		$this->start_controls_tabs( 'button_style_tabs' );

		$this->start_controls_tab(
			'button_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'button_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'button_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'button_box_shadow',
				'selector' => '{{WRAPPER}} .gn-auth-action-btn',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'button_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'button_text_color_hover',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:hover' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'button_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'button_border_color_hover',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'button_box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-auth-action-btn:hover',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'button_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'button_text_color_focus',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:focus' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'button_background_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'button_border_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-btn:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'button_box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-auth-action-btn:focus',
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'button_border',
				'separator' => 'before',
				'selector'  => '{{WRAPPER}} .gn-auth-action-btn',
			)
		);

		$this->add_responsive_control(
			'button_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-action-btn' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'button_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-action-btn' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'button_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-action-btn' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'loader_style',
			array(
				'label'     => esc_html__( 'Loader', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_responsive_control(
			'btn_loader_size',
			array(
				'label'      => __( 'Size', 'gigneo' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', '%', 'em' ),
				'range'      => array(
					'px' => array(
						'min'  => 5,
						'max'  => 30,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-actions .gn-loading::after' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'     => 'btn_loader_border',
				'selector' => '{{WRAPPER}} .gn-auth-actions .gn-loading::after',
			)
		);

		$this->add_control(
			'btn_loader_border_top_color',
			array(
				'label'     => __( 'Border Top Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-actions .gn-loading::after' => 'border-top-color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'btn_loader_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-actions .gn-loading::after' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'dont_have_account_style',
			array(
				'label' => esc_html__( "Don't Have An Account", 'gigneo' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'have_account_typography',
				'label'    => esc_html__( 'Typography', 'gigneo' ),
				'selector' => '{{WRAPPER}} .gn-auth-action-text',
			)
		);

		$this->add_control(
			'have_account_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-auth-action-text' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_responsive_control(
			'have_account_text_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-action-text' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'have_account_text_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-auth-action-text' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'sign_up_style',
			array(
				'label'     => esc_html__( 'Sign Up', 'gigneo' ),
				'type'      => Controls_Manager::HEADING,
				'separator' => 'before',
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'sign_up_typography',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_PRIMARY,
				),
				'selector' => '{{WRAPPER}} .gn-sign-up',
			)
		);

		$this->start_controls_tabs( 'sign_up_style_tabs' );

		$this->start_controls_tab(
			'sign_up_normal',
			array( 'label' => esc_html__( 'Normal', 'gigneo' ) )
		);

		$this->add_control(
			'sign_up_text_color',
			array(
				'label'     => esc_html__( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_background',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_text_decoration',
			array(
				'label'     => esc_html__( 'Text Decoration', 'gigneo' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'underline',
				'options'   => array(
					'none'         => esc_html__( 'None', 'gigneo' ),
					'underline'    => esc_html__( 'Underline', 'gigneo' ),
					'overline'     => esc_html__( 'Overline', 'gigneo' ),
					'line-through' => esc_html__( 'Line Through', 'gigneo' ),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up' => 'text-decoration: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'sign_up_box_shadow',
				'selector' => '{{WRAPPER}} .gn-sign-up',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'sign_up_hover',
			array( 'label' => esc_html__( 'Hover', 'gigneo' ) )
		);

		$this->add_control(
			'sign_up_text_color_hover',
			array(
				'label'     => __( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:hover' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_background_hover',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:hover' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_border_color_hover',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:hover' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_text_decoration_hover',
			array(
				'label'     => esc_html__( 'Text Decoration', 'gigneo' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'underline',
				'options'   => array(
					'none'         => esc_html__( 'None', 'gigneo' ),
					'underline'    => esc_html__( 'Underline', 'gigneo' ),
					'overline'     => esc_html__( 'Overline', 'gigneo' ),
					'line-through' => esc_html__( 'Line Through', 'gigneo' ),
				),
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:hover' => 'text-decoration: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'sign_up_box_shadow_hover',
				'selector' => '{{WRAPPER}} .gn-sign-up:hover',
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'sign_up_focus',
			array( 'label' => esc_html__( 'Focus', 'gigneo' ) )
		);

		$this->add_control(
			'sign_up_text_color_focus',
			array(
				'label'     => __( 'Text Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:focus' => 'color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_background_focus',
			array(
				'label'     => esc_html__( 'Background Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'default'   => '',
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:focus' => 'background-color: {{VALUE}};',
				),
			)
		);

		$this->add_control(
			'sign_up_border_color_focus',
			array(
				'label'     => __( 'Border Color', 'gigneo' ),
				'type'      => Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .gn-sign-up:focus' => 'border-color: {{VALUE}};',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'sign_up_box_shadow_focus',
				'selector' => '{{WRAPPER}} .gn-sign-up:focus',
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->add_group_control(
			Group_Control_Border::get_type(),
			array(
				'name'      => 'sign_up_border',
				'separator' => 'before',
				'selector'  => '{{WRAPPER}} .gn-sign-up',
			)
		);

		$this->add_responsive_control(
			'sign_up_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-sign-up' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'sign_up_text_padding',
			array(
				'label'      => esc_html__( 'Padding', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-sign-up' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'sign_up_text_margin',
			array(
				'label'      => esc_html__( 'Margin', 'gigneo' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', 'em', '%' ),
				'selectors'  => array(
					'{{WRAPPER}} .gn-sign-up' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();
	}

	/**
	 * Render widget output on the frontend.
	 *
	 * Uses a template file to separate PHP/HTML from logic.
	 */
	protected function render() {
		// Include the frontend template for the widget.
		require gigneo_get_template( 'elementor/widgets/login' );
	}
}
